//LightRay3D SDK (C) 2002-2006 Tzivenis Sakis

#include <stdio.h>
#include <windows.h>
#include <commctrl.h>

#include "resource.h"
#include "plugapi.h"
#include "api.h"
#include "cnode.h"
#include "impexpq23.h"
#include "interface.h"
#include "dlg.h"


//Import Q2 & Q3
static int numframes=0,frame=0;
static BOOL CALLBACK ImpDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);


int ChooseFrame(int nframes)
{
	if(nframes<2) return 0;
	numframes=nframes;
	frame=0;
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_IMP_QUAKE),(HWND)Interface::GetMainHWND(),(DLGPROC)ImpDlgProc);
	return frame;
}


BOOL CALLBACK ImpDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	char txt[32];
	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(txt,"%d",numframes);
		SendDlgItemMessage(hDlg,IDC_QFRAME_NUM,WM_SETTEXT,0,(LPARAM)txt);
		SendDlgItemMessage(hDlg,IDC_QFRAME_FRAME,WM_SETTEXT,0,(LPARAM)"0");
		return 1;

	case WM_COMMAND: 
		switch (LOWORD(wParam))
		{ 
		case IDOK:
			*(short *)txt=sizeof(txt)-1;
			int l=SendDlgItemMessage(hDlg,IDC_QFRAME_FRAME,EM_GETLINE,0,(LPARAM)txt);
			txt[l]=0;
			frame=atoi(txt);
			if(frame<0) frame=0;
			else if(frame>=numframes) frame=numframes-1;
			EndDialog(hDlg, 1);
			return 1;
		}	
		break;
	}

	return 0;
}


//Export Quake3 globals
int g_q3_startframe=0,g_q3_endframe=0;
BOOL g_q3_bEnableWarnings=TRUE;
BOOL g_q3_bUseModels=TRUE;
BOOL g_q3_bHasTags=FALSE;
int g_q3_tag_relative=TAG_RELATIVE_NONE;
char g_q3_tag_name[128]="";

static BOOL CALLBACK ExpDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);


int ExportQuake3Options()
{
	int iret=DialogBox(hInstance,MAKEINTRESOURCE(IDD_EXP_QUAKE3),(HWND)Interface::GetMainHWND(),(DLGPROC)ExpDlgProc);
	if(iret==IDOK) return 1;
	return 0;
}


BOOL CALLBACK ExpDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	int l;
	char txt[128];
	switch (uMsg)
    {
	case WM_INITDIALOG:
		sprintf(txt,"%d",g_q3_startframe);
		SendDlgItemMessage(hDlg,IDC_EXP_Q3_START_FRAME,WM_SETTEXT,0,(LPARAM)txt);
		sprintf(txt,"%d",g_q3_endframe);
		SendDlgItemMessage(hDlg,IDC_EXP_Q3_END_FRAME,WM_SETTEXT,0,(LPARAM)txt);

		if(g_q3_bHasTags)
		{
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_TORSO),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_HEAD),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_WEAPON),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_USER),TRUE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_NAME),TRUE);
			SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_NAME,WM_SETTEXT,0,(LPARAM)g_q3_tag_name);
		}
		else
		{
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_TORSO),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_HEAD),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_WEAPON),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_USER),FALSE);
			EnableWindow(GetDlgItem(hDlg,IDC_EXP_Q3_TAG_NAME),FALSE);
			SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_NAME,WM_SETTEXT,0,(LPARAM)"");
		}
		SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_NONE,BM_SETCHECK,BST_CHECKED,0);

		SendDlgItemMessage(hDlg,IDC_EXP_Q3_USE_MODELS_PATH,BM_SETCHECK,(g_q3_bUseModels)?BST_CHECKED:BST_UNCHECKED,0);
		SendDlgItemMessage(hDlg,IDC_EXP_Q3_ENABLE_WARNINGS,BM_SETCHECK,(g_q3_bEnableWarnings)?BST_CHECKED:BST_UNCHECKED,0);

		return 1;

	case WM_COMMAND: 
		switch (LOWORD(wParam))
		{ 
		case IDOK:
			*(short *)txt=sizeof(txt)-1;
			l=SendDlgItemMessage(hDlg,IDC_EXP_Q3_START_FRAME,EM_GETLINE,0,(LPARAM)txt);
			txt[l]=0;
			g_q3_startframe=atoi(txt);
			if(g_q3_startframe<0) g_q3_startframe=0;

			*(short *)txt=sizeof(txt)-1;
			l=SendDlgItemMessage(hDlg,IDC_EXP_Q3_END_FRAME,EM_GETLINE,0,(LPARAM)txt);
			txt[l]=0;
			g_q3_endframe=atoi(txt);
			if(g_q3_endframe<0) g_q3_endframe=0;

			if(g_q3_startframe>g_q3_endframe)
			{
				MessageBox(::GetActiveWindow(),"Start Frame  must be < End Frame!","Export MD3",MB_ICONWARNING);
				return 1;
			}

			if(BST_CHECKED==SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_NONE,BM_GETCHECK,0,0))
				g_q3_tag_relative=TAG_RELATIVE_NONE;
			else if(BST_CHECKED==SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_TORSO,BM_GETCHECK,0,0))
				g_q3_tag_relative=TAG_RELATIVE_TORSO;
			else if(BST_CHECKED==SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_HEAD,BM_GETCHECK,0,0))
				g_q3_tag_relative=TAG_RELATIVE_HEAD;
			else if(BST_CHECKED==SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_WEAPON,BM_GETCHECK,0,0))
				g_q3_tag_relative=TAG_RELATIVE_WEAPON;
			else if(BST_CHECKED==SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_USER,BM_GETCHECK,0,0))
			{
				*(short *)txt=sizeof(txt)-1;
				l=SendDlgItemMessage(hDlg,IDC_EXP_Q3_TAG_NAME,EM_GETLINE,0,(LPARAM)txt);
				txt[l]=0;
				cnode *usernode=Interface::FindNode(txt);
				if(!usernode)
				{
					MessageBox(::GetActiveWindow(),"No such object name found in scene!","Export MD3",MB_ICONWARNING);
					return 1;
				}
				else
				{
					if(usernode->GetFlags()&FLAG_HIDDEN)
					{
						MessageBox(::GetActiveWindow(),"Named object is hidden.\nCannot be used, must unhide it first!","Export MD3",MB_ICONWARNING);
						return 1;
					}
					if(!strstr(usernode->GetName(),"tag_"))
					{
						MessageBox(::GetActiveWindow(),"'tag_' prefix is missing from named object.\nCannot be used!","Export MD3",MB_ICONWARNING);
						return 1;
					}
				}
				strcpy(g_q3_tag_name,txt);
				g_q3_tag_relative=TAG_RELATIVE_USER;
			}

			EndDialog(hDlg, 1);
			return 1;

		case IDCANCEL:
			EndDialog(hDlg,0);
			return 1;
		}	
		break;
	}

	return 0;
}
