#ifndef QUAKE3_H
#define QUAKE3_H

//*.MD3
typedef float vec3_t[3];
typedef float mat3_t[9];
typedef float texcoord_t[2];

#define MD3_ID_HEADER	 (*(int*)"IDP3")
#define MD3_ALIAS_VERSION	15

// vertex scales
#define	MD3_XYZ_SCALE		(1.0/64)

typedef struct
{
    int				id;//char id[4];
    int				version;
    char			filename[64];//68 if no flags
	int				flags;
    int				numboneframes;
    int				numtags;
    int				nummeshes;
    int				numskins;
    int				bone_offs;
    int				tag_offs;
    int				mesh_offs;
    int				filesize;
} md3header_t;

typedef struct
{
    int				id;//char id[4];
    char			name[64];//68 if no flags
	int				flags;
    int				numframes;
    int				numskins;
    int				numverts;
    int				numtris;
    int				elem_offs;
    int				skin_offs;
    int				tc_offs;
    int				vert_offs;
    int				meshsize;
} md3mesh_file_t;

typedef struct
{
    char name[64];
    vec3_t pos;
    mat3_t rot;
} md3tag_t;

typedef struct
{
    vec3_t			mins;
	vec3_t			maxs;
    vec3_t			pos;
    float			scale;
    char			creator[16];
} md3boneframe_t;

typedef struct
{
    signed short vec[3];
    unsigned char tc[2];
} md3vert_t;

typedef struct
{
    int shader;          /* Shader reference */
    int numverts;
    vec3_t *points;
    texcoord_t *tex_st;  /* Texture coords */
    texcoord_t *env_st;  /* Used for environment mapping ? */
    int numelems;
    unsigned int *elems;
} md3mesh_t;

typedef struct
{
    vec3_t			mins;
	vec3_t			maxs;
    int				nummeshes;
    md3mesh_t		*meshes;
} md3model_t;

#endif //QUAKE3_H