// Lightray3D (C) 2002-2006 Tzivenis Sakis

#ifndef IMODIFY_H
#define IMODIFY_H

#include "iclass.h"


class CGLWindow;
class cgizmo;
class cnode;

class COREAPI cmodifyinterface : public cclassinterface
{
public:
	//From cclassinterface
	//{
	char *GetCategory(){return "";}//Don't use
	char *GetName(){return "";}
	//NOTE:Normally this is always TRUE
	BOOL IsPublic(){return TRUE;}//Return FALSE if this class isn't shown in Control Panel
	UINT GetType(){return 0;}//Don't use
	UINT GetSubType(){return 0;}//Don't use
	void* Create(){return NULL;}//Don't use
	//If having a dialog must handle messages
	BOOL DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam){return FALSE;}
	//(ver.>=1.3.6 update1):Function moved to base class cclassinterface
	//(ver.>=1.3.5):Added renderflags param(see cnode.h)
	void Display(int attime,CGLWindow*,UINT renderflags){}//if having a gizmo render it in here
	//}



	virtual void Init(){}
	virtual void Done(){}

	virtual cgizmo* GetGizmo()const {return NULL;}
	virtual void GizmoTransformed(){}//(ver.>=1.3.4):Handle gizmo Pos,Rot,Scale changes.
	virtual BOOL UseApply(){return TRUE;}//(ver.>=1.3.4):Is this modifier using Apply(Execute)?
	virtual BOOL Execute()=0;//Apply
	virtual void Update(){}//handle this for recalculations after scene/object(s) changes,
	virtual BOOL IsOkToModify(cnode*)=0;//is called to enable/disable modifier
										//every time selection state changes
	virtual BOOL OwnUndo(){return FALSE;}//(ver.>=1.3.6 update1):Is this modifier using own undo?
};

COREAPI BOOL RegisterInterface(cmodifyinterface*);
COREAPI void UnregisterModifyInterfaces();
COREAPI int GetNumModifyInterfaces();
COREAPI cmodifyinterface* GetModifyInterface(int i);
//COREAPI cmodifyinterface* GetModifyInterfaceByName(const char*);
//COREAPI cmodifyinterface* GetModifyInterfaceClass(UINT type,UINT subtype);
//(ver.>=1.3.6 update1)
COREAPI void SetActiveModifyInterface(cmodifyinterface*);
COREAPI cmodifyinterface* GetActiveModifyInterface();


#endif //IMODIFY_H