// Lightray3D (C) 2002-2006 Tzivenis Sakis
//(ver.>=1.3.5):Added Utility interface

#ifndef IUTILITY_H
#define IUTILITY_H

#include "iclass.h"


//Notification Messages handled by Utilities.Almost all o these messages are posted by the application.
//Create,modify,utility plugins can/may use SendUtilityMessage() func.

#define UTIL_MSG_NONE						0	//param1=0, param2=0
#define UTIL_MSG_UPDATE						1	//General update message.param1=see Param1, param2=0
#define UTIL_MSG_APP_SEL_CHANGED			2	//param1=0, param2=0
#define UTIL_MSG_APP_SUBSEL_CHANGED			3	//param1=0, param2=0
#define UTIL_MSG_APP_SEL_VISCHANGED			4	//param1=0, param2=0
#define UTIL_MSG_APP_SUBSEL_VISCHANGED		5	//param1=0, param2=(cnode*) object which elements are hidden/shown
#define UTIL_MSG_APP_SEL_PREDELETE			6	//param1=0, param2=0
#define UTIL_MSG_APP_SEL_POSTDELETE			7	//param1=0, param2=0
#define UTIL_MSG_APP_SUBSEL_PREDELETE		8	//param1=0, param2=(cnode*) object which elements are about to be deleted
#define UTIL_MSG_APP_SUBSEL_POSTDELETE		9	//param1=0, param2=(cnode*) object which elements are deleted
#define UTIL_MSG_APP_OBJ_ADDED				10	//param1=0, param2=(cnode*) object OR 0 if more than 1 added
#define UTIL_MSG_APP_OBJ_CHANGED			11	//param1=see Param1, param2=(cnode*) object OR 0 if more than 1
#define UTIL_MSG_APP_OBJ_TYPECONVERTED		12	//param1=(cnode*) old type object, param2=(cnode*) new type object
#define UTIL_MSG_APP_MAT_ADDED				13	//param1=0, param2=(cmaterial*) OR 0 if more than 1 added
#define UTIL_MSG_APP_MAT_CHANGED			14	//param1=see Param1, param2=(cmaterial*) OR 0 if more than 1
#define UTIL_MSG_APP_MAT_PREDELETE			15	//param1=0, param2=(cmaterial*) OR 0 if more than 1 selected
#define UTIL_MSG_APP_MAT_POSTDELETE			16	//param1=0, param2=(cmaterial*) OR 0 if more than 1 selected
#define UTIL_MSG_APP_MAT_UPDATE				17	//param1=0, param2=(cmaterial*) OR 0 if more than 1 selected
#define	UTIL_MSG_APP_ANIMCHANGED			18	//param1=see Param1, param2=depending on Param1 can be a frame num.
#define UTIL_MSG_APP_PREEDITANIM			19	//param1=0, param2=0
#define UTIL_MSG_APP_POSTEDITANIM			20	//param1=TRUE if dialog exited with IDOK else 0, param2=0
#define UTIL_MSG_APP_PRENEW					21	//param1=0, param2=0
#define UTIL_MSG_APP_POSTNEW				22	//param1=0, param2=0
#define UTIL_MSG_APP_PRELOAD				23	//param1=0, param2=0
#define UTIL_MSG_APP_POSTLOAD				24	//param1=0, param2=0
#define UTIL_MSG_APP_PREMERGE				25	//param1=0, param2=0
#define UTIL_MSG_APP_POSTMERGE				26	//param1=0, param2=0
#define UTIL_MSG_APP_IMPORT					27	//param1=0, param2=0
#define UTIL_MSG_APP_CREATESTART			28	//param1=0, param2=0
#define UTIL_MSG_APP_CREATEEND				29	//param1=0, param2=0
#define UTIL_MSG_APP_MODIFY					30	//param1=see Param1, param2=depends on Param1
#define UTIL_MSG_APP_ENV_CHANGED			31	//param1=see Param1, param2=depends on Param1
#define UTIL_MSG_APP_VIEWCHANGED			32	//param1=see Param1, param2=depends on Param1
//Interface/plugins calls
#define UTIL_MSG_RAW_OBJ_ADDED				100	//param1=0, param2=(cnode*) object OR 0 if more than 1 added
#define UTIL_MSG_RAW_OBJ_DELETED			101	//param1=TRUE if deleted - FALSE if just removed from scene, param2=(cnode*) object OR 0 if more than 1 removed/deleted
#define UTIL_MSG_RAW_MAT_ADDED				102	//param1=0, param2=(cmaterial*) OR 0 if more than 1 added
#define UTIL_MSG_RAW_SEL_CHANGED			103	//param1=0, param2=(cnode*) object OR 0 if more than 1 selected
#define UTIL_MSG_RAW_VISCHANGED				104	//param1=0, param2=(cnode*) object OR 0 if more than 1 hidden/unhidden


//Param1 - LOWORD values
#define UTIL_PARAM_NONE						0
#define UTIL_PARAM_RESET					1	//Reset data
#define UTIL_PARAM_RESET_MAT				2	//Reset objects'/objects faces' material(s)

#define UTIL_PARAM_MISC						3	//Misc variable changed
#define UTIL_PARAM_TYPE						4	//Object type changed(i.e spot light to point light)
#define UTIL_PARAM_NAME						5	//Name changed
#define UTIL_PARAM_COLOR					6	//Color changed.For materials HIWORD value = type of color, i.e MAT_COL_AMBIENT(see cmaterial.h)

//material
#define UTIL_PARAM_IMAGE					10	//Image changed.HIWORD value = type of image, i.e MAT_IMG_DIFFUSE(see cmaterial.h)
#define UTIL_PARAM_AMOUNT					11	//Image Amount changed.HIWORD value = type of image, i.e MAT_IMG_DIFFUSE(see cmaterial.h)
#define UTIL_PARAM_SHINE					12	//Shininess value changed
#define UTIL_PARAM_TRANS					13	//Diffuse Image transparency flag changed. HIWORD is a boolean value.
#define UTIL_PARAM_ALPHA					14	//Diffuse Image alpha channel flag changed. HIWORD is a boolean value.
#define UTIL_PARAM_OGL_FX					15	//Enable/Disable OpenGL image fx rendering flag changed. HIWORD is a boolean value.

//environment
#define UTIL_PARAM_COLOR_AMBIENT			20	//Env ambient color changed
#define UTIL_PARAM_COLOR_BKGND				21	//Env bkgnd color changed
#define UTIL_PARAM_FOG						22	//Fog params changed
#define	UTIL_PARAM_FOG_ENABLE				23	//param2=Boolean TRUE or FALSE

//mesh/skin/shape - LOWORD
#define UTIL_PARAM_GEOM						30	//Geom changed

//animation
#define UTIL_PARAM_FRAME					40 //Frame changed, param2 is the current frame num
#define UTIL_PARAM_START					41 //Anim start frame changed, param2 is the start frame num
#define UTIL_PARAM_END						42 //Anim end frame changed, param2 is the end frame num
#define UTIL_PARAM_TPF						43 //Anim Ticks Per Frame changed, param2 is the tpf num
#define UTIL_PARAM_SETKEY					44 //Set Key pressed, param2=0
#define UTIL_PARAM_DELKEY					45 //Del Key pressed, param2=0
#define UTIL_PARAM_COPYKEY					46 //Copy Key pressed, param2=0
#define UTIL_PARAM_PASTEKEY					47 //Paste Key pressed, param2=0
#define UTIL_PARAM_RECORD					48 //REC button state changed, param2= 1 if ON 0 if off
#define UTIL_PARAM_PLAY						49 //Play button state changed, param2= 1 if ON 0 if off

//modify
#define UTIL_PARAM_INIT						60 //Modifier initialized
#define UTIL_PARAM_DONE						61 //Modifier fini
#define UTIL_PARAM_APPLY					62 //Modifier applied

//viewports
#define UTIL_PARAM_VIEW_MAX					70	//Minimize/Maximize active viewport - param2=Boolean TRUE=max FALSE=min
#define UTIL_PARAM_VIEW_ENABLE				71	//Enable/Disable viewport(hiword val=view id) - param2=Boolean TRUE=enable FALSE=disable
#define UTIL_PARAM_VIEW_ACTIVE				72	//Active view changed - param2=view id
#define UTIL_PARAM_VIEW_SETCAMERA			73	//hiword val = view id - param2=(cnode*) camera object
#define UTIL_PARAM_VIEW_REMOVECAMERA		74	//param2=view id

//general update
#define UTIL_PARAM_UNDO						100 //Undo



//Param1 - HIWORD values for UTIL_PARAM_GEOM
//Mesh & General
#define UTIL_PARAM_DIVIDE					 1	//Edge(s)/Face(s) Divided
#define UTIL_PARAM_MIRROR					 2	//Object/Sub Elements Mirrored
#define UTIL_PARAM_EXTRUDE					 3	//Edge(s)/Face(s) Extruded
#define UTIL_PARAM_UV						 4	//Edit UV
#define UTIL_PARAM_NEW_ELEMENT				 5	//New sub element created(i.e vertex,face,edge)
#define UTIL_PARAM_SMGROUP					 6	//Smoothing groups changed
#define UTIL_PARAM_EDGEROTATE				 7	//Edge(s) Rotated
#define UTIL_PARAM_BREAK					 8	//Break op on Vert(s)/Face(s)/Edge(s)
#define UTIL_PARAM_WELD						 9	//Weld Vertices
#define UTIL_PARAM_ATTACH					10	//Attach

//Skin object HIWORD values for UTIL_PARAM_GEOM
//NOTE: Some of the skin operations below don't really affect geometry 
//but do affect geometry's extended data such as weights, vertex bones etc.
#define UTIL_PARAM_RESET_SKINVERTS			101	//Reset skin verts
#define UTIL_PARAM_REMOVE_BONE				102	//Remove bone(multi-weights)
#define UTIL_PARAM_NORM_WEIGHTS				103	//Normalize weights(multi-weights)
#define UTIL_PARAM_SET_WEIGHT				104	//Set weight
#define UTIL_PARAM_ASSIGN_BONE				105	//Assign to bone
#define UTIL_PARAM_ADD_BONE					106	//Add bone(multi-weights)
#define UTIL_PARAM_REPLACE_MESH				107	//Replace skin mesh data
#define UTIL_PARAM_SET_POSE					108	//Set pose(update geom data)
#define UTIL_PARAM_UPDATE_BONES				109	//Update bones(recalc weights etc.)
#define UTIL_PARAM_BIND						110	//Bind skin to bones
#define UTIL_PARAM_LOCK_SKIN				111	//(ver.>=1.3.6):Lock skin geometry
#define UTIL_PARAM_REPLACE_BONE				112	//(ver.>=1.3.6 update1):Replace bone


COREAPI DWORD GetUtilityLastMessage();
COREAPI DWORD GetUtilityLastParam1();
COREAPI DWORD GetUtilityLastParam2();
COREAPI void SendUtilityMessage(DWORD msg,DWORD param1,DWORD param2);//only those currently "running"
COREAPI void SendUtilityMessageToAll(DWORD msg,DWORD param1,DWORD param2);//send to all


class CGLWindow;
class cnode;

class COREAPI cutilityinterface : public cclassinterface
{
public:
	//From cclassinterface
	//{
	char *GetCategory(){return "";}//Don't use
	char *GetName(){return "";}
	//NOTE:Normally this is always TRUE
	BOOL IsPublic(){return TRUE;}//Return FALSE if this class isn't shown in Control Panel
	UINT GetType(){return 0;}//Don't use
	UINT GetSubType(){return 0;}//Don't use
	void* Create(){return NULL;}//Don't use
	//If having a dialog must handle messages
	BOOL DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam){return FALSE;}
	//(ver.>=1.3.6 update1):Function moved to base class cclassinterface
	//(ver.>=1.3.5):Added renderflags param(see cnode.h)
	void Display(int attime,CGLWindow*,UINT renderflags){}
	//}




	cutilityinterface()
	{
		bRunning=FALSE;
	}

	virtual BOOL Run()=0;
	virtual void Close()=0;
	void ut_Run(BOOL b) {bRunning=b;}//Dont use.Called by app when utility dlg Run/Close buttons pressed.
	virtual BOOL IsRunning(){return bRunning;}

	//Notification Messages are posted to utility plugins whenever objects/app state changes
	//Return TRUE if message handled
	virtual BOOL HandleMessage(DWORD msg,DWORD param1,DWORD param2);

private:
	BOOL bRunning;
};

COREAPI BOOL RegisterInterface(cutilityinterface*);
COREAPI void UnregisterUtilityInterfaces();
COREAPI int GetNumUtilityInterfaces();
COREAPI cutilityinterface* GetUtilityInterface(int i);
//COREAPI cutilityinterface* GetUtilityInterfaceByName(const char*);
//COREAPI cutilityinterface* GetUtilityInterfaceClass(UINT type,UINT subtype);

#endif //IUTILITY_H