// Lightray3D (C) 2002-2006 Tzivenis Sakis

#ifndef UVMAPPER_H
#define UVMAPPER_H


#define UVMAP_PLANE			0
#define UVMAP_BOX			1
#define UVMAP_CYLINDER		2
#define UVMAP_SPHERE		3

//(ver.>=1.3.5):Added cylindrical capping.

//Map single point.
COREAPI BOOL ApplyUVMap(cpoint3& uv,const cpoint3& pt,
						const cpoint3& normal,//normal used for BOX mapping,cylindrical capping(usually normal of the face that owns this point)
						int type,BOOL bCap,
						BOOL bFlipU,BOOL bFlipV,
						float uscale,float vscale,//tiling
						const cmatrix4& tm);

//(ver.>=1.3.5):Map face pts(3).Corrects wrongly wrapped uv points(cyl,sphere).
COREAPI BOOL ApplyFaceUVMap(cpoint3 *uv,const cpoint3 *pt,//uv & pt must be [3]
							const cpoint3& normal,//normal used for BOX mapping,cylindrical capping(usually normal of the face that owns this point)
							int type,BOOL bCap,
							BOOL bFlipU,BOOL bFlipV,
							float uscale,float vscale,//tiling
							const cmatrix4& tm);

#endif //UVMAPPER_H