// Lightray3D (C) 2002-2006 Tzivenis Sakis

#ifndef CBITARRAY_H
#define CBITARRAY_H


class COREAPI cbitarray
{
public:
	cbitarray(int s=0);//Will allocate 's' sized array
	~cbitarray();

	void SetSize(int s,int reset=0);//If reset=1 sets all to 0.
	void Set(int i);//Set ith element to 1
	void SetAll();//Set all to 1
	void Reset(int i);//Set ith element to 0
	void ResetAll();//Set all to 0
	void Set(int i,long val);//Set ith to val
	void SetAll(long val);//Set all to val
	int	GetSize() const { return size; }
	int NumBitsSet();//returns non zero bits number
	int NumZeroBits();//returns zero bits number

	//Access operator
	long operator[](int i) const;

	//Assignment operators
	cbitarray& operator=(const cbitarray& b);
private:
	unsigned long*	bits;
	int		size;
};
//(ver.>=1.3.4):Added
COREAPI void Copy(cbitarray& dest,cbitarray& src);


//(ver.>=1.3.5)
class COREAPI cfloatarray
{
public:
	cfloatarray(int s=0);//Will allocate 's' sized array
	~cfloatarray();

	void SetSize(int s,int reset=0);//If reset=1 sets all to 0.
	void Set(int i);//Set ith element to 1.0f
	void SetAll();//Set all to 1.0f
	void Reset(int i);//Set ith element to 0.0f
	void ResetAll();//Set all to 0
	void Set(int i,float val);//Set ith to val
	void SetAll(float val);//Set all to val
	int	GetSize() const { return size; }
	int NumValsSet();//returns non zero values number
	int NumZeroVals();//returns zero values number

	//Access operator
	float operator[](int i) const;

	//Assignment operators
	cfloatarray& operator=(const cfloatarray& b);
private:
	float*	values;
	int		size;
};
COREAPI void Copy(cfloatarray& dest,cfloatarray& src);



#endif //CBITARRAY_H