// Lightray3D (C) 2002-2006 Tzivenis Sakis

#ifndef CCAMERA_H
#define CCAMERA_H

//(ver>=1.3):added depth range and enabled target,ortho

#include "cnode.h"
#include "ccamanim.h"


class COREAPI ccamera : public cnode
{
public:
	ccamera();
	~ccamera();
	void Delete();

	void Create(const cpoint3&,const cpoint3& dir,const cpoint3& up);
	void Create(float x,float y,float z,
				float dirx,float diry,float dirz,
				float upx,float upy,float upz);

	void Ortho(BOOL);
	void SetTarget(cnode*);
	void SetDistance(float);
	void SetFOV(int attime,float);
	void SetDepthNear(float);
	void SetDepthFar(float);

	BOOL IsOrtho() const;
	float GetDistance() const;
	float GetFOV(int attime) const;
	cnode* GetTarget();
	float GetDepthNear() const;
	float GetDepthFar() const;

	//Light animation
	ccamanim* GetCamAnimPtr(){return &camanim;}

	//From cnode
	BOOL Clone(int attime,cnode&) const;
	//(ver.>=1.3.5):allowed after users request
//	void SetColor(const ccolor& clr){}//Changing color is not allowed
	//If target exists must filter orientation calls bypassing normal camera's rotation
	//{
	void SetRotation(int attime,const cquat&);
	cquat GetRotation(int attime) const;
//	void Rotate(int attime,const cquat&,const cpoint3& center);
	//}
	void UpdateTimeIdle();
	void SnapKey();
	void DeleteKey(int attime);
	BOOL HasKey(int attime);
//	void MoveKeys(int pos,int from,int to);//(ver.>=1.3.1):Let app handle this
	//(ver.>=1.3.6 update1):Added HitTest to handle delta
	BOOL HitTest(int attime,CGLWindow*,int x,int y,float *zvalue,float delta);
	void Flash(int attime,CGLWindow*);
	//(ver.>=1.3.5):Added render flags parameter(see cnode.h)
	void Render(int attime,CGLWindow*,UINT rflags);

	//IO methods
	BOOL Load(cio_load& iload,DWORD fileversion);//support for previous file versions
	BOOL Save(cio_save& isave);

	BOOL HandleMessage(DWORD msg,void *Param1,void *Param2);
//	void NodeIsBeingDeleted(cnode*);//now using HandleMessage

protected:
	float fov,distance;
	float fnear,ffar;
	BOOL bOrtho;
	cnode *target;
	ccamanim camanim;
};

//(ver.>=1.3.2)://Use this instead of the new operator
COREAPI ccamera* CreateNewCamera();

#endif //CCAMERA_H