// Lightray3D (C) 2002-2006 Tzivenis Sakis

#ifndef CIO_H
#define CIO_H

//Func result types
typedef int IORes; 
#define CIO_ERROR	-1
#define CIO_OK		0

//Seek method constants as defined in stdio.h
#ifndef SEEK_SET
#define SEEK_SET        0  // seek to an absolute position
#define SEEK_CUR        1  // seek relative to current position
#define SEEK_END        2  // seek relative to end of file
#endif


// Simple disk file I/O class
class COREAPI cio
{
public:
	cio();
	virtual ~cio();

	virtual IORes Open(const char *filename)=0;
	IORes Close();
	long GetPosition();//Retrieves current position bytes offset
	long SetPosition(long lOffset,int origin);//Use SEEK_CUR,SEEK_END,SEEK_SET for origin
	long Size();

protected:
	/*FILE*/void *hFile;
};

//Derived load file class
class COREAPI cio_load : public cio
{
public:
	cio_load();
	~cio_load();

	IORes Open(const char *filename);
	IORes Read(void *buffer,UINT size);
	IORes Skip(UINT size);
};

//Derived save file class
class COREAPI cio_save : public cio
{
public:
	cio_save();
	~cio_save();

	IORes Open(const char *filename);
	IORes Write(void *buffer,UINT size);
	IORes Skip(char val,UINT size);
};

#endif //CIO