// Lightray3D (C) 2002-2006 Tzivenis Sakis

//(ver.>=1.3.6):Use this class to create meshes that pack 
//vertices in a single structure i.e {xyz,normal,uv}

#ifndef UNIQUE_MESH_H
#define UNIQUE_MESH_H

#include "cbitarray.h"
#include "cmesh.h"
#include "cskin.h"
#include "Array.h"

class COREAPI cuniquevert
{
public:
	cuniquevert();
	~cuniquevert();

	cpoint3 v,n,tv;
	WORD wFlags;
};


class COREAPI cuniquemesh
{
public:
	cuniquemesh();
	~cuniquemesh();

	void Delete();

	void Clear();

	BOOL BuildFromMesh(cmesh *mesh);
	BOOL BuildFromSkin(cskin *skin);
	//Skin Objects Only: will replace vertex points and normals depending on bVerts,bNorms flags
	BOOL CalcSkinVertsAtFrame(int attime,BOOL bVerts=TRUE,BOOL bNorms=TRUE);

//protected:
	cnode *node;					//could be mesh OR skin (check TypeID)
	Array<cuniquevert> vertsarray;	//array may be greater than original num verts
	cbitarray faceindex;			//new face indices pointing to vertsarray( 3*nfaces )
	cbitarray invalidfaces;			//if invalidfaces[?]==1 then invalid, skip
	int nvalidfaces;				//num of valid(non degenerate) faces
	cbitarray orgvindex;			//this array stores the original vertex indices
};

//Can use this instead of the new operator
COREAPI cuniquemesh* CreateNewUniqueMesh();

#endif //UNIQUE_MESH_H