// Lightray3D (C) 2002-2006 Tzivenis Sakis

#ifndef RENDERMESH_H
#define RENDERMESH_H


typedef struct {
    cpoint3 v[3];
    cpoint3 n[3];
    cpoint3 tv[3];
	ccolor col;
	cmaterial* mat;
} Triangle;

class COREAPI RenderMesh
{
public:
	RenderMesh();
	~RenderMesh();
	void Delete();

	void Allocate(int size);
	void Clear();
	void AddTriangle(const Triangle& tri);
	void SetTriangle(int i,const Triangle& tri);
	BOOL GetTriangleAt(int i,Triangle& tri);

	int NumTriangles() const {return num_tris;}

private:
	Triangle *tris;
	int num_tris;
};

//(ver.>=1.3.2)://Use this instead of the new operator
COREAPI RenderMesh* CreateNewRenderMesh();

#endif //RENDERMESH_H