//LightRay3D SDK (C) 2002-2006 Tzivenis Sakis

#ifndef SPHERE_H
#define SPHERE_H

#include "icreate.h"
#include "cmesh.h"

class PLUGINAPI ccreatesphere : public ccreateinterface
{
	BOOL bCorner;//(ver.>=1.3.6 update1)
public:
	ccreatesphere();

	char *GetCategory(){return CATEGORY_PRIMITIVES;}
	char *GetName(){return "Sphere(SDK)";}
	UINT GetType(){return TYPE_MESH;}
	UINT GetSubType(){return 0;}
	void* Create(){return CreateNewMesh();}//don't use new operator
	BOOL DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);

	void Init();
	void Done();

	BOOL BeginDrag(CGLWindow *glwnd,int scrx,int scry,
				   float x,float y,float z,
				   float dirx,float diry,float dirz,
				   float upx,float upy,float upz);
	BOOL Drag(CGLWindow *glwnd,int scrx,int scry,int scrdx,int scrdy,
			  float x,float y,float z,float szx,float szy);
	BOOL EndDrag(CGLWindow *glwnd,int scrx,int scry,int scrdx,int scrdy,
				 float x,float y,float z,float szx,float szy);
	//(ver.>=1.3.6 update1):Let user cancel/delete while creating
	BOOL Stop(CGLWindow *glwnd,int scrx,int scry,int scrdx,int scrdy,
			  float x,float y,float z,float szx,float szy);

	//(ver.>=1.3.6 update1):HBITMAP icon for listbox( 24x24 )
	void* GetHBitmap();
	void DeleteHBitmap(void*hbmp);
};


#endif //SPHERE_H